#ifndef _PRIMITIVE_H
#define _PRIMITIVE_H

#include "world_entity.h"
#include "glincl.h"

typedef enum pForm {P_SPHERE = 0, P_CUBE, P_CYLINDER, P_DISK};

class Material;

class Primitive : public WorldEntity 
{
  friend class World;

 public:
  Primitive (pForm form);
  virtual ~Primitive ();

  virtual void tick (float time);
  virtual void hit (WorldEntity* weapon, Vector* loc);
  virtual void collide (WorldEntity* other,  Uint32 ownhitflags, Uint32 otherhitflags);

  virtual void draw ();
  void glDrawCube();


 private:
  GLUquadricObj *object; //!< the object to be rendered
  Material *material;    //!< A Material for the SkySphere.
  pForm form;

};

#endif /* _PRIMITIVE_H */
